/*
 * $Id: Button.java,v 1.3 2006/02/11 17:19:32 Yuki Exp $
 */
package hsplet.gui;

import hsplet.Context;
import hsplet.JumpTask;
import hsplet.function.JumpStatement;
import hsplet.variable.Operand;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * button Rg[B
 * <p>
 * NbNꂽWv^XNo^B
 * </p>
 * 
 * @author Yuki
 * @version $Revision: 1.3 $, $Date: 2006/02/11 17:19:32 $
 */
public class Button extends javax.swing.JButton implements ActionListener, HSPControl {

	/** ̃NX܂ރ\[Xt@C̃o[WB */
	private static final String fileVersionID = "$Id: Button.java,v 1.3 2006/02/11 17:19:32 Yuki Exp $";

	/** 񉻕ɁAf[^̌݊mF邽߂̃o[WԍB */
	private static final long serialVersionUID = 7638106082988894456L;

	/**
	 * IuWFNg\zB
	 * @param text {^ɕ\eLXgB
	 * @param context sĂReLXgB
	 * @param jump Wv̎ށB
	 * @param label Wv惉xB
	 */
	public Button(final String text, final Context context, final JumpStatement jump, final int label) {

		super(text);
		this.context = context;
		this.jump = jump;
		this.label = label;

		addActionListener(this);
	}

	private final Context context;

	private final JumpStatement jump;

	private final int label;

	public void actionPerformed(ActionEvent e) {

		context.tasks.add(new JumpTask(jump, label, null, null, null));
	}

	public Component asComponent() {
		return this;
	}

	public void setValue(Operand v, int vi) {

		setLabel(v.toString(vi));
	}

}
